export var convertSchemaComponent = function (fields, components, containers, container) {
    if (Array.isArray(fields)) {
        fields.forEach(function (field) { return convertSchemaComponent(field, components, containers, container); });
    }
    else {
        containers[container].children.push(fields.name);
        components[fields.name] = fields;
        if (fields.component === 'sub-form') {
            if (!containers[fields.name]) {
                containers[fields.name] = {
                    children: []
                };
            }
            fields.fields.forEach(function (subField) { return convertSchemaComponent(subField, components, containers, fields.name); });
        }
    }
};
var convertSchema = function (schema) {
    var components = {};
    var containers = {
        root: {
            children: [],
            ref: null
        }
    };
    if (schema) {
        convertSchemaComponent(schema.fields, components, containers, 'root');
    }
    return { components: components, containers: containers };
};
export default convertSchema;
//# sourceMappingURL=convert-schema.js.map