var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React from 'react';
import omit from 'lodash/omit';
import isEqual from 'lodash/isEqual';
import FormRenderer from '@data-driven-forms/react-form-renderer/form-renderer';
import useFormApi from '@data-driven-forms/react-form-renderer/use-form-api';
import FormSpy from '@data-driven-forms/react-form-renderer/form-spy';
import useState from '@data-driven-forms/dnd/use-state';
import useDispatch from '@data-driven-forms/dnd/use-dispatch';
var FormTemplate = function (_a) {
    var formFields = _a.formFields;
    var handleSubmit = useFormApi().handleSubmit;
    return (React.createElement("form", { onSubmit: handleSubmit }, formFields));
};
var EditorFormSpy = function (_a) {
    var onChange = _a.onChange;
    return React.createElement(FormSpy, { subscription: { values: true }, onChange: function (e) { return onChange(e.values); } });
};
var Properties = function (_a) {
    var componentMapper = _a.componentMapper, _b = _a.fields, fields = _b === void 0 ? [] : _b;
    var state = useState();
    var dispatch = useDispatch();
    var selectedComponent = state.components[state.selectedComponent] || state.containers[state.selectedComponent];
    if (!selectedComponent) {
        return React.createElement("span", null, "No selected component");
    }
    return React.createElement(FormRenderer, { initialValues: omit(selectedComponent, ['ref']), schema: {
            fields: __spreadArray([
                {
                    component: 'editor-form-spy', name: 'editor-form-spy', onChange: function (values) {
                        if (!isEqual(omit(selectedComponent, ['ref']), values)) {
                            dispatch({
                                type: 'UPDATE_PROPS',
                                id: state.selectedComponent,
                                props: values
                            });
                        }
                    }
                }
            ], fields, true)
        }, clearedValue: null, onSubmit: function () { return undefined; }, FormTemplate: FormTemplate, componentMapper: __assign({ 'editor-form-spy': EditorFormSpy }, componentMapper) });
};
export default Properties;
//# sourceMappingURL=properties.js.map