"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var omit_1 = __importDefault(require("lodash/omit"));
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var form_renderer_1 = __importDefault(require("@data-driven-forms/react-form-renderer/form-renderer"));
var use_form_api_1 = __importDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));
var form_spy_1 = __importDefault(require("@data-driven-forms/react-form-renderer/form-spy"));
var use_state_1 = __importDefault(require("@data-driven-forms/dnd/use-state"));
var use_dispatch_1 = __importDefault(require("@data-driven-forms/dnd/use-dispatch"));
var FormTemplate = function (_a) {
    var formFields = _a.formFields;
    var handleSubmit = (0, use_form_api_1.default)().handleSubmit;
    return (react_1.default.createElement("form", { onSubmit: handleSubmit }, formFields));
};
var EditorFormSpy = function (_a) {
    var onChange = _a.onChange;
    return react_1.default.createElement(form_spy_1.default, { subscription: { values: true }, onChange: function (e) { return onChange(e.values); } });
};
var Properties = function (_a) {
    var componentMapper = _a.componentMapper, _b = _a.fields, fields = _b === void 0 ? [] : _b;
    var state = (0, use_state_1.default)();
    var dispatch = (0, use_dispatch_1.default)();
    var selectedComponent = state.components[state.selectedComponent] || state.containers[state.selectedComponent];
    if (!selectedComponent) {
        return react_1.default.createElement("span", null, "No selected component");
    }
    return react_1.default.createElement(form_renderer_1.default, { initialValues: (0, omit_1.default)(selectedComponent, ['ref']), schema: {
            fields: __spreadArray([
                {
                    component: 'editor-form-spy', name: 'editor-form-spy', onChange: function (values) {
                        if (!(0, isEqual_1.default)((0, omit_1.default)(selectedComponent, ['ref']), values)) {
                            dispatch({
                                type: 'UPDATE_PROPS',
                                id: state.selectedComponent,
                                props: values
                            });
                        }
                    }
                }
            ], fields, true)
        }, clearedValue: null, onSubmit: function () { return undefined; }, FormTemplate: FormTemplate, componentMapper: __assign({ 'editor-form-spy': EditorFormSpy }, componentMapper) });
};
exports.default = Properties;
//# sourceMappingURL=properties.js.map